"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUrlLoadRows = void 0;
var react_1 = __importDefault(require("react"));
var primeobjects_ui_web_application_1 = require("primeobjects-ui-web-application");
var action_button_1 = __importDefault(require("primeobjects-ui-web-application/build/cjs/controls/action-button"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var in_progress_1 = require("primeobjects-ui-web-application/build/cjs/controls/in-progress");
var getUrlLoadRows = function (props) {
    var _a, _b, _c, _d, _e;
    var record = props.record, onDoing = props.onDoing, isDoing = props.isDoing, solution = props.solution, show = props.show, isError = props.isError, onError = props.onError, toRefreshForm = props.toRefreshForm, onFinishProcess = props.onFinishProcess, primaryColor = props.primaryColor;
    var processSettings = (_a = props.processSettings) !== null && _a !== void 0 ? _a : {};
    var name = (_b = props.name) !== null && _b !== void 0 ? _b : "url";
    var label = (_c = props.label) !== null && _c !== void 0 ? _c : "Address/URL";
    var placeholder = (_d = props.placeholder) !== null && _d !== void 0 ? _d : "Type the address/URLhere";
    var action = "process-web-page";
    var url = record[name];
    var onClickLoadWebContent = function () {
        if ((0, primeobjects_helper_util_1.isNonEmptyString)(url)) {
            onDoing(action, true);
            (0, primeobjects_ui_web_application_1.callApi)(solution, (0, primeobjects_ui_web_application_1.getApiEndpoint)(solution, "content", "process-web-page"), 
            // "http://localhost:3000/prod/process-web-page ",
            { url: url }, "POST")
                .then(function (response) {
                var result = (0, primeobjects_helper_util_1.processWebPage)(url, response.result, __assign({ keepLongestPipeInTitle: true, removeTitleFromContent: true }, processSettings));
                if (result) {
                    if (result === null || result === void 0 ? void 0 : result.error) {
                        onError(action, "failed", result === null || result === void 0 ? void 0 : result.error);
                    }
                    else {
                        onFinishProcess(result);
                    }
                }
                toRefreshForm();
            })
                .catch(function (error) {
                onError(action, "failed", error);
            })
                .finally(function () {
                onDoing(action, false);
            });
        }
    };
    return show
        ? [
            {
                style: { paddingBottom: "0.5rem" },
                fields: [
                    {
                        name: name,
                        label: label,
                        type: "single-line-input",
                        alwaysShowLabel: (_e = props.alwaysShowLabel) !== null && _e !== void 0 ? _e : true,
                        format: "url",
                        placeholder: placeholder
                    }
                ]
            },
            isError(action, "failed") && {
                name: "".concat(name, "ProcessFailed"),
                type: "container",
                content: (react_1.default.createElement("div", { className: "w-full text-red-600 px-3 pb-3" }, "Sorry, it was failed to load and process the web content. Note: some web addresses are protected by authentication or not allowed to be crawled by external script."))
            },
            !isDoing(action) && {
                fields: [
                    {
                        name: "".concat(name, "LoadButtons"),
                        content: (react_1.default.createElement("div", { className: "w-full" },
                            react_1.default.createElement(action_button_1.default, { id: "".concat(name, "LoadButton"), onClick: onClickLoadWebContent, wrapperClassName: "bg-sky-500 hover:bg-sky-600 float-left min-w-36 px-3", wrapperStyle: { marginLeft: 0 }, text: "Load web content", textColor: primeobjects_helper_util_1.COLORS.WHITE }))),
                        type: "custom"
                    }
                ]
            },
            isDoing(action) && {
                fields: [
                    {
                        name: "".concat(name, "Loading"),
                        content: (react_1.default.createElement(in_progress_1.InProgress, { primaryColor: primaryColor, text: "loading and processing the web page ..." })),
                        type: "custom"
                    }
                ]
            }
        ]
        : [];
};
exports.getUrlLoadRows = getUrlLoadRows;
//# sourceMappingURL=url-load-rows.js.map