var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from "react";
import { isNumber } from "lodash";
import { numberWithCommas } from "primeobjects-helper-util";
export var MIN_RESULT_LENGTH_VALUE = 300;
export var STEP_RESULT_LENGTH_VALUE = 50;
export var MAX_RESULT_LENGTH_VALUE = 4 * 3500;
export var getMaxResultLengthRows = function (props) {
    var _a, _b;
    var fieldName = props.fieldName, record = props.record, primaryColor = props.primaryColor, tab = props.tab, skipRecordUpdate = props.skipRecordUpdate, labelColor = props.labelColor, labelClassName = props.labelClassName, labelStyle = props.labelStyle;
    var minResultLength = (_a = props.minResultLength) !== null && _a !== void 0 ? _a : MIN_RESULT_LENGTH_VALUE;
    var maxResultLength = (_b = props.maxResultLength) !== null && _b !== void 0 ? _b : MAX_RESULT_LENGTH_VALUE;
    var defaultValue = isNumber(props.defaultValue) && props.defaultValue > 0
        ? props.defaultValue
        : minResultLength;
    var value = tab == "run" ? props.value : record[fieldName];
    var onClickReset = function () {
        if (props.onClickReset)
            return props.onClickReset();
    };
    return [
        {
            style: { paddingBottom: "0.2rem" },
            fields: [
                {
                    name: "".concat(fieldName, "Label"),
                    lineClassName: labelClassName,
                    lineStyle: labelColor
                        ? __assign({ color: labelColor }, labelStyle) : labelStyle,
                    line: "Max. ".concat(numberWithCommas(value), " result characters"),
                    colStyle: { maxWidth: 220, minWidth: 220 },
                    labelSVGClassName: "self-center",
                    type: "label"
                },
                {
                    colStyle: {
                        marginLeft: 0,
                        paddingLeft: 0,
                        width: 140,
                        maxWidth: 140,
                        flex: "none"
                    },
                    name: fieldName,
                    hideLabel: true,
                    stepValue: STEP_RESULT_LENGTH_VALUE,
                    defaultValue: defaultValue,
                    maxValue: maxResultLength,
                    minValue: minResultLength,
                    type: "slider",
                    value: value,
                    useFieldValue: tab == "run",
                    skipRecordUpdate: skipRecordUpdate,
                    onChange: props.onChange
                },
                tab == "run" &&
                    props.onClickReset && {
                    colStyle: {
                        marginLeft: 20,
                        paddingLeft: 0,
                        flex: "none"
                    },
                    name: "".concat(fieldName, "ResetButton"),
                    hideLabel: true,
                    type: "container",
                    content: (React.createElement("button", { className: "text-white p-2 bg-".concat(primaryColor.name, "-400 hover:bg-").concat(primaryColor.name, "-500 text-xs shadow hover:shadow-lg justify-center rounded mt-2 leading-none"), onClick: onClickReset }, "Reset"))
                }
            ]
        }
    ];
};
//# sourceMappingURL=max-result-length-rows.js.map